package bussinesslogic;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class ApplicationProperties {

	public static String USER = "";
	public static String PASSWORD = "";
	public static Boolean PRODUCTIVE;
	public static String UTC_OFFSET = "";

	public static void initProperties() throws IOException {
		Properties prop = new Properties();
		InputStream input = null;

		try {
			input = new FileInputStream("config.properties");
			prop.load(input);
			USER = prop.getProperty("MERCHANT_USERNAME");
			PASSWORD = prop.getProperty("MERCHANT_PASSWORD");
			PRODUCTIVE = new Boolean(prop.getProperty("PRODUCTIVE"));
			UTC_OFFSET = prop.getProperty("UTC_OFFSET");

			if (USER == null || USER.isEmpty() || PASSWORD == null || PASSWORD.isEmpty() || UTC_OFFSET == null
					|| UTC_OFFSET.isEmpty() || PRODUCTIVE == null) {
				throw new IllegalArgumentException("Please fill out all  properties in the config.properties file! (e.g. merchant user and merchant password)");
			}

		} catch (Exception ex) {
			throw ex;
		} finally {
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					throw e;
				}
			}
		}
	}

}
