package view;

import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import util.ErrorHandler;
import bussinesslogic.ApplicationProperties;
import bussinesslogic.SOPGRefundMerchantClient;

public class MainView {

	private JFrame frmPaysafecardMerchantRefund;
	private JTextField customerMailAdressTextField;
	private JTextField rtidTextField;
	private JTextField mtidTextField;
	private JTextField merchantClientIdTextField;
	private JTextField amountTextField;
	private JTextField currencyTextField;
	private JCheckBox validateOnlyCheckBox;
	private JTextArea resultTextArea;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					MainView window = new MainView();
					window.frmPaysafecardMerchantRefund.setVisible(true);
					ApplicationProperties.initProperties();
				} catch (Exception e) {
					ErrorHandler.handleError(e);
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public MainView() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmPaysafecardMerchantRefund = new JFrame();
		frmPaysafecardMerchantRefund.setTitle("Paysafecard merchant refund test suite ");
		frmPaysafecardMerchantRefund.setBounds(100, 100, 812, 751);
		frmPaysafecardMerchantRefund.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmPaysafecardMerchantRefund.getContentPane().setLayout(null);

		JLabel lblPaysafecardMerchantRefund = new JLabel("Paysafecard merchant refund test suite ");
		lblPaysafecardMerchantRefund.setBounds(10, 11, 434, 15);
		lblPaysafecardMerchantRefund.setVerticalAlignment(SwingConstants.TOP);
		lblPaysafecardMerchantRefund.setHorizontalAlignment(SwingConstants.LEFT);
		lblPaysafecardMerchantRefund.setFont(new Font("Tahoma", Font.BOLD, 12));
		frmPaysafecardMerchantRefund.getContentPane().add(lblPaysafecardMerchantRefund);

		JLabel lblNewLabel = new JLabel("Refund transaction id (rtid)");
		lblNewLabel.setBounds(10, 37, 159, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(lblNewLabel);

		JLabel lblNewLabel_1 = new JLabel("Merchant transaction id (mtid)");
		lblNewLabel_1.setBounds(10, 67, 174, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(lblNewLabel_1);

		JLabel lblMerchantClientId = new JLabel("Merchant client id");
		lblMerchantClientId.setBounds(10, 97, 143, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(lblMerchantClientId);

		JLabel lblAmount = new JLabel("Amount");
		lblAmount.setBounds(10, 127, 77, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(lblAmount);

		JLabel lblCurrency = new JLabel("Currency");
		lblCurrency.setBounds(10, 157, 77, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(lblCurrency);

		JLabel label_3 = new JLabel("____________________________________________________________________________");
		label_3.setBounds(10, 221, 594, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(label_3);

		JLabel lblNewLabel_2 = new JLabel("My paysafecard customer mail adress");
		lblNewLabel_2.setBounds(10, 238, 228, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(lblNewLabel_2);

		JLabel lblNewLabel_3 = new JLabel("(to be provided if the original mtid was paid with classic)");
		lblNewLabel_3.setBounds(10, 252, 354, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(lblNewLabel_3);

		customerMailAdressTextField = new JTextField();
		customerMailAdressTextField.setBounds(10, 277, 256, 20);
		frmPaysafecardMerchantRefund.getContentPane().add(customerMailAdressTextField);
		customerMailAdressTextField.setColumns(10);

		JButton processDataBtn = new JButton("Process data");
		processDataBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {

				resultTextArea.setText("");

				// example data
//				 customerMailAdressTextField.setText("HGbuuRXnAZ@IOcjHLWzGE.uvK");
//				 mtidTextField.setText("test_1415878002_4");
//				 merchantClientIdTextField.setText("rand_mcid141587800264");
//				 amountTextField.setText("10.00");
				// example data

				if (customerMailAdressTextField.getText().equals("") || mtidTextField.getText().equals("")
						|| merchantClientIdTextField.getText().equals("") || amountTextField.getText().equals("")) {
					JOptionPane.showMessageDialog(null, "Please fill out all textfields!", "Error",
							JOptionPane.ERROR_MESSAGE);
					return;
				}

				SOPGRefundMerchantClient refundClient = new SOPGRefundMerchantClient(ApplicationProperties.USER,
						ApplicationProperties.PASSWORD, ApplicationProperties.PRODUCTIVE);
				refundClient.setTransaction(amountTextField.getText(), currencyTextField.getText(),
						mtidTextField.getText(), rtidTextField.getText(), ApplicationProperties.UTC_OFFSET);
				refundClient.setCustomer(merchantClientIdTextField.getText(), customerMailAdressTextField.getText(),
						null);

				HashMap<String, String> result = null;
				try {
					result = refundClient.refund(validateOnlyCheckBox.isSelected());
				} catch (Exception e) {
					ErrorHandler.handleError(e);
				}

				customerMailAdressTextField.setText("");
				rtidTextField.setText("");
				mtidTextField.setText("");
				merchantClientIdTextField.setText("");
				amountTextField.setText("");

				if (result == null) {
					resultTextArea.setText("No results!");
					return;
				}

				for (String key : result.keySet()) {
					resultTextArea.append(key + ": " + result.get(key) + "\n");
				}
			}
		});
		processDataBtn.setBounds(10, 315, 159, 23);
		frmPaysafecardMerchantRefund.getContentPane().add(processDataBtn);

		JLabel lblResults = new JLabel("Results");
		lblResults.setBounds(10, 365, 60, 14);
		frmPaysafecardMerchantRefund.getContentPane().add(lblResults);

		rtidTextField = new JTextField();
		rtidTextField.setColumns(10);
		rtidTextField.setBounds(194, 34, 189, 20);
		frmPaysafecardMerchantRefund.getContentPane().add(rtidTextField);

		mtidTextField = new JTextField();
		mtidTextField.setColumns(10);
		mtidTextField.setBounds(194, 64, 189, 20);
		frmPaysafecardMerchantRefund.getContentPane().add(mtidTextField);

		merchantClientIdTextField = new JTextField();
		merchantClientIdTextField.setColumns(10);
		merchantClientIdTextField.setBounds(194, 94, 189, 20);
		frmPaysafecardMerchantRefund.getContentPane().add(merchantClientIdTextField);

		amountTextField = new JTextField();
		amountTextField.setColumns(10);
		amountTextField.setBounds(194, 124, 91, 20);
		frmPaysafecardMerchantRefund.getContentPane().add(amountTextField);

		currencyTextField = new JTextField();
		currencyTextField.setColumns(10);
		currencyTextField.setBounds(194, 154, 91, 20);
		currencyTextField.setText("EUR");
		frmPaysafecardMerchantRefund.getContentPane().add(currencyTextField);

		resultTextArea = new JTextArea();
		resultTextArea.setEditable(false);
		resultTextArea.setBounds(10, 390, 776, 312);
		frmPaysafecardMerchantRefund.getContentPane().add(resultTextArea);

		validateOnlyCheckBox = new JCheckBox("validate only");
		validateOnlyCheckBox.setSelected(true);
		validateOnlyCheckBox.setBounds(194, 181, 143, 23);
		frmPaysafecardMerchantRefund.getContentPane().add(validateOnlyCheckBox);
	}
}
